CREATE SCHEMA if not exists siiu;
set search_path TO siiu ,"$user",public; 

create table if not exists siiu.estado_orden_pago
(
    id          bigint generated by default as identity
        primary key,
    descripcion varchar(254)
);

alter table siiu.estado_orden_pago
owner to postgres;

create table if not exists siiu.estado_tramite
(
    id        bigint generated by default as identity
        primary key,
    estado    varchar(20),
    secuencia integer
);

alter table siiu.estado_tramite
    owner to postgres;

create table if not exists requisito
(
    id             bigint generated by default as identity
        primary key,
    descripcion    varchar(254),
    nombre_tramite varchar(254)
);

alter table siiu.requisito
    owner to postgres;

create table if not exists siiu.tipo_notificacion
(
    id                bigint generated by default as identity
        primary key,
    tipo_notificacion varchar(254)
);

alter table siiu.tipo_notificacion
    owner to postgres;

create table if not exists siiu.tipo_pago
(
    id          bigint generated by default as identity
        primary key,
    descripcion varchar(254)
);

alter table siiu.tipo_pago
    owner to postgres;

create table if not exists siiu.comprobante_pago
(
    id              bigint generated by default as identity
        primary key,
    fecha_pago      timestamp,
    literal         varchar(255),
    total_cancelado numeric(19, 2),
    id_orden_pago   bigint,
    id_tipo_pago    bigint
        constraint idtipopago
            references tipo_pago
);

alter table siiu.comprobante_pago
    owner to postgres;

create table if not exists siiu.tramite
(
    id             bigint generated by default as identity
        primary key,
    costo          numeric(19, 2),
    descripcion    varchar(254),
    duracion       integer,
    nombre_tramite varchar(254)
);

alter table siiu.tramite
    owner to postgres;

create table if not exists siiu.solicitud
(
    id                bigint generated by default as identity
        primary key,
    fecha_entrega     timestamp,
    fecha_solicitud   timestamp,
    solicitante_id    varchar(8),
    tipo_notificacion varchar(254),
    id_tramite        bigint
        constraint idtramite
            references tramite
);

alter table siiu.solicitud
    owner to postgres;

create table if not exists siiu.orden_pago
(
    id                  bigint generated by default as identity
        primary key,
    costo               numeric(19, 2),
    fecha_emision       timestamp,
    fecha_vencimiento   timestamp,
    token               varchar(255),
--     id_comprobante_pago bigint
--         constraint idcomprobantepago
--             references comprobante_pago,
    id_estado_orden_pago bigint
        constraint fkljxseaibje3em06cwta2esk6e
            references estado_orden_pago,
    id_solicitud        bigint
        constraint idsolicitud
            references solicitud
);

alter table siiu.orden_pago
    owner to postgres;

ALTER TABLE siiu.comprobante_pago DROP CONSTRAINT IF EXISTS idordenpago;
alter table siiu.comprobante_pago add constraint idordenpago foreign key (id_orden_pago) references siiu.orden_pago;

create table if not exists siiu.tramite_requisito
(
    id_tramite   bigint not null
        constraint fkn0acfa35buowfveksx76k0bmv
            references tramite,
    id_requisito bigint not null
        constraint fk6iu7qdh18ol775eu8cywuh94d
            references requisito,
    primary key (id_tramite, id_requisito)
);

alter table siiu.tramite_requisito
    owner to postgres;

create table if not exists siiu.unidad
(
    id            bigint generated by default as identity
        primary key,
    codigo_unidad varchar(10),
    nombre_unidad varchar(254)
);

alter table siiu.unidad
    owner to postgres;

create table if not exists siiu.hoja_ruta
(
    id                bigint generated by default as identity
        primary key,
    estado            boolean,
    fecha_fin         timestamp,
    fecha_inicio      timestamp,
    user_id           varchar(255),
    id_estado_tramite bigint
        constraint idestadotramite
            references estado_tramite,
    id_tramite        bigint
        constraint idtramite
            references solicitud,
    id_unidad         bigint
        constraint idunidad
            references unidad
);

alter table siiu.hoja_ruta
    owner to postgres;

create table if not exists siiu.notificacion
(
    id                       bigint generated by default as identity
        primary key,
    contenido                varchar(20000),
    emisor_id                varchar(254),
    fecha_envio              timestamp,
    receptor_id              varchar(254),
    servicio_notificacion_id bigint,
    id_hoja_ruta             bigint
        constraint idhojaruta
            references hoja_ruta,
    id_tipo_notificacion     bigint
        constraint idtiponotificacion
            references tipo_notificacion
);

alter table siiu.notificacion
    owner to postgres;

create table if not exists siiu.validacion_requisito
(
    id           bigint generated by default as identity
        primary key,
    estado       boolean,
    id_requisito varchar(10),
    id_solicitud bigint
        constraint idsolicitud
            references solicitud
);

alter table siiu.validacion_requisito
    owner to postgres;

-----------------------
-----------------------
------- Indexes -------
-----------------------
-----------------------

CREATE INDEX if not exists idx_hoja_ruta_solicitud ON siiu.hoja_ruta (id_tramite);
CREATE INDEX if not exists idx_hoja_ruta_fecha_inicio ON siiu.hoja_ruta (fecha_inicio);
CREATE INDEX if not exists idx_hoja_ruta_fecha_fin ON siiu.hoja_ruta (fecha_fin);
CREATE INDEX if not exists idx_hoja_ruta_estado ON siiu.hoja_ruta (estado);

-----------------------
-----------------------
-------- Data --------
-----------------------
-----------------------

INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 1, 'Orden Generada' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 1);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 2, 'En espera' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 2);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 3, 'En Proceso' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 3);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 4, 'Pendiente' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 4);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 5, 'Bloqueado' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 5);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 6, 'Obsoleto' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 6);
INSERT INTO siiu.estado_orden_pago(id, descripcion) SELECT 7, 'Exitoso' WHERE NOT EXISTS (
SELECT id FROM siiu.estado_orden_pago WHERE id = 7);


----------------------------------------------------------
----------------------------------------------------------
-------- Trigger Inserta fecha entrega de tramite --------
----------------------------------------------------------
----------------------------------------------------------

create or replace function siiu.insert_fecha_entrega () returns trigger
as
$$
BEGIN
update siiu.solicitud set fecha_entrega=CAST(new.fecha_solicitud AS DATE)+(select duracion from tramite where id=new.id_tramite)
where id=new.id;
return new;
END 
$$
language plpgsql;

create or replace TRIGGER tr_update_fec AFTER insert on solicitud
for EACH row
execute procedure siiu.insert_fecha_entrega();




